# Property 3: when the null port controller can accept a cell, transceiver board
#             has a cell to send and null port controller is in normal operation
#             (ctr_sz = 0), the memory address will set up  and increment
#             properly, and data will be transferred correctly.
# Internal singal involved method
# Step 1: verify the 5 assumptions:(3.3.c.a.1 ~ 3.3.c.a.5)
 AG(npc_rst_n = 1);                                                            
 AG(state = S1 -> ctr_id = 0 * ctr_sz = 0 * ip_empty = 1 * rx_rd_req = 1 );
 AG(state = S1 -> framestart = 1);
 AG((state = S2 + state = S3 + state = S15) -> framestart = 0);
 AG(state = S3 -> rx_ip_soc = 1);
# Step 2: verify the conclusion.
 AG(state = S4 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S3[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S3[0]);
 AG(state = S5 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S3[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S3[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S4[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S4[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 0 * 
                  ip_mem_addr_c[2] = 1 * 
                  ip_mem_addr_c[1] = 0 * 
                  ip_mem_addr_c[0] = 0 );
 AG(state = S6 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S3[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S3[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S4[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S4[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 0 * 
                  ip_mem_addr_c[2] = 1 * 
                  ip_mem_addr_c[1] = 0 * 
                  ip_mem_addr_c[0] = 1 );
 AG(state = S7 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S3[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S3[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S4[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S4[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 0 * 
                  ip_mem_addr_c[2] = 1 * 
                  ip_mem_addr_c[1] = 1 * 
                  ip_mem_addr_c[0] = 0 );
 AG(state = S8 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S3[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S3[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S4[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S4[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 0 * 
                  ip_mem_addr_c[2] = 1 * 
                  ip_mem_addr_c[1] = 1 * 
                  ip_mem_addr_c[0] = 1 );
 AG(state = S8 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S3[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S3[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S4[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S4[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 0 * 
                  ip_mem_addr_c[2] = 1 * 
                  ip_mem_addr_c[1] = 1 * 
                  ip_mem_addr_c[0] = 1 );
 AG(state = S9 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S3[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S3[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S4[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S4[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 1 * 
                  ip_mem_addr_c[2] = 0 * 
                  ip_mem_addr_c[1] = 0 * 
                  ip_mem_addr_c[0] = 0 );
 AG(state = S10 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S3[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S3[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S4[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S4[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 1 * 
                  ip_mem_addr_c[2] = 0 * 
                  ip_mem_addr_c[1] = 0 * 
                  ip_mem_addr_c[0] = 1 );
 AG(state = S11 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S3[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S3[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S4[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S4[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 1 * 
                  ip_mem_addr_c[2] = 0 * 
                  ip_mem_addr_c[1] = 1 * 
                  ip_mem_addr_c[0] = 0 );
 AG(state = S12 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S3[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S3[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S4[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S4[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 1 * 
                  ip_mem_addr_c[2] = 0 * 
                  ip_mem_addr_c[1] = 1 * 
                  ip_mem_addr_c[0] = 1 );
 AG(state = S13 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S3[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S3[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S4[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S4[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 1 * 
                  ip_mem_addr_c[2] = 1 * 
                  ip_mem_addr_c[1] = 0 * 
                  ip_mem_addr_c[0] = 0 );
 AG(state = S14 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S3[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S3[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S4[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S4[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 1 * 
                  ip_mem_addr_c[2] = 1 * 
                  ip_mem_addr_c[1] = 0 * 
                  ip_mem_addr_c[0] = 1 );
 AG(state = S15 -> AX(ip_mem_addr_r[8] == input_data0.rx_ip_data_S3[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S3[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S4[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S4[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 0 * 
                  ip_mem_addr_c[2] = 0 * 
                  ip_mem_addr_c[1] = 0 * 
                  ip_mem_addr_c[0] = 0) );
 AG((state = S1 + state = S2 + state = S3)  ->
                  ip_mem_addr_r[8] == npc0.ip_mem_addr_r_r1[8] *
                  ip_mem_addr_r[1] == npc0.ip_mem_addr_r_r1[1] *
                  ip_mem_addr_c[8] == npc0.ip_mem_addr_c_r1[8] *
                  ip_mem_addr_c[6] == npc0.ip_mem_addr_c_r1[6] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 0 * 
                  ip_mem_addr_c[2] = 0 * 
                  ip_mem_addr_c[1] = 0 * 
                  ip_mem_addr_c[0] = 0 );
# data transfer
 AG((state = S1 + state = S2 + state = S3) -> ip_mem_wr_en = 0);
 AG((state = S6 + state = S7 + state = S8 + state = S9 + state = S10
     + state = S11 + state = S12 + state = S13 + state = S14
     ) -> ip_mem_wr_en = 1);
 AG(state = S6 -> ip_mem_data[0] == input_data0.rx_ip_data_S5[0] *
                  ip_mem_data[7] == input_data0.rx_ip_data_S5[7]);
 AG(state = S7 -> ip_mem_data[0] == input_data0.rx_ip_data_S6[0] *
                  ip_mem_data[7] == input_data0.rx_ip_data_S6[7]);
 AG(state = S8 -> ip_mem_data[0] == input_data0.rx_ip_data_S7[0] *
                  ip_mem_data[7] == input_data0.rx_ip_data_S7[7]);
 AG(state = S9 -> ip_mem_data[0] == input_data0.rx_ip_data_S8[0] *
                  ip_mem_data[7] == input_data0.rx_ip_data_S8[7]);
