# Property 3: when the null port controller can accept a cell, transceiver board
#             has a cell to send and null port controller is in normal operation
#             (ctr_sz = 0), the memory address will set up  and increment
#             properly, and data will be transferred correctly.
# Internal singal involved method
# Step 1: verify the 5 assumptions:
 AG(npc_rst_n = 1);                                                            
 AG(state = S1 -> ctr_id = 0 * ctr_sz = 0 * ip_empty = 1 * rx_rd_req = 1 );
 AG(state = S1 -> framestart = 1);
 AG((state = S2 + state = S3 + state = S64) -> framestart = 0);
 AG(state = S3 -> rx_ip_soc = 1);
# Step 2: verify the conclusion.
 AG(state = S5 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S4[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S4[0]);
 AG(state = S6 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S4[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S4[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S5[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S5[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 0 * 
                  ip_mem_addr_c[2] = 1 * 
                  ip_mem_addr_c[1] = 0 * 
                  ip_mem_addr_c[0] = 0 );
 AG(state = S7 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S4[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S4[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S5[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S5[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 0 * 
                  ip_mem_addr_c[2] = 1 * 
                  ip_mem_addr_c[1] = 0 * 
                  ip_mem_addr_c[0] = 1 );
 AG(state = S8 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S4[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S4[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S5[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S5[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 0 * 
                  ip_mem_addr_c[2] = 1 * 
                  ip_mem_addr_c[1] = 1 * 
                  ip_mem_addr_c[0] = 0 );
 AG(state = S55 -> ip_mem_addr_r[8] == input_data0.rx_ip_data_S4[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S4[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S5[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S5[4] *
                  ip_mem_addr_c[5] = 1 * 
                  ip_mem_addr_c[4] = 1 * 
                  ip_mem_addr_c[3] = 0 * 
                  ip_mem_addr_c[2] = 1 * 
                  ip_mem_addr_c[1] = 0 * 
                  ip_mem_addr_c[0] = 1 );
 AG((state = S57 + state = S64)->
                  ip_mem_addr_r[8] == input_data0.rx_ip_data_S4[7] *
                  ip_mem_addr_r[1] == input_data0.rx_ip_data_S4[0] *
                  ip_mem_addr_c[8] == input_data0.rx_ip_data_S5[6] *
                  ip_mem_addr_c[6] == input_data0.rx_ip_data_S5[4] *
                  ip_mem_addr_c[5] = 0 * 
                  ip_mem_addr_c[4] = 0 * 
                  ip_mem_addr_c[3] = 0 * 
                  ip_mem_addr_c[2] = 0 * 
                  ip_mem_addr_c[1] = 0 * 
                  ip_mem_addr_c[0] = 0 );
# data transfer
 AG((state = S1 + state = S6 + state = S57 + state = S64) -> ip_mem_wr_en = 0);
 AG((state = S7 + state = S8 + state = S9 + state = S56) -> ip_mem_wr_en = 1);
 AG(state = S7 -> ip_mem_data[0] == input_data0.rx_ip_data_S6[0] *
                  ip_mem_data[7] == input_data0.rx_ip_data_S6[7]);
 AG(state = S56 -> ip_mem_data[0] == input_data0.rx_ip_data_S55[0] *
                   ip_mem_data[7] == input_data0.rx_ip_data_S55[7]);
